#include <bits/stdc++.h>

using namespace std;

#define fastio() ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;

const int N = 1e5 + 10;
const int INF = 1e9 + 10;
const int MOD = 1971971971;

int n, m, a[N], b[N], h[N], H[N], pref[N], suf[N], deg[N], p = 203;
unordered_map<int, bool> mp;

int mul(ll f, ll s) {
    return f * s % MOD;
}

int pl(ll f, ll s) {
    return (f + s + MOD) % MOD;
}

ll pr(int i) {
    if (i < 0) return 0;
    return pref[i + 1];
}

ll ps(int i) {
    if (i >= n) return 0;
    return suf[i];
}

ll get_p(int l, int r) {
    return pl(pr(r), -mul(pr(l - 1), deg[r - l + 1]));
}

ll get_s(int l, int r) {
    return pl(ps(l), -mul(ps(r + 1), deg[r - l + 1]));
}

int func(int L, int R) {
    int l = 0, r = min(n - R - 1, L) + 1;
    while (r - l > 1) {
        int mid = (l + r) >> 1;
        (get_p(L - mid, L) == get_s(R, R + mid) ? l : r) = mid;
    }
    return l * 2 + (L == R);
}

int main() {
#ifdef DEBUG
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
#endif
    fastio()

    cin >> n >> m;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int i = 0; i < m; ++i)
        cin >> b[i];

    bool ok = 1;
    int ans = 1;
    for (int i = 1; i < m; ++i)
        ok &= (b[i] == b[i - 1]);
    deg[0] = 1;
    pref[0] = suf[n] = 0;

    assert(ok);
    for (int i = 0; i < n; ++i) {
        deg[i + 1] = mul(deg[i], p);
        pref[i + 1] = pl(mul(pref[i], p), a[i]);
    }
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = pl(mul(suf[i + 1], p), a[i]);
    }

    for (int i = 0; i < n; ++i) {
        ans = max(ans, func(i, i));
        if (i + 1 < n)
            ans = max(ans, func(i, i + 1));
    }
    cout << ans;
}
