#include <bits/stdc++.h>

using namespace std;

#define fastio() ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;

const int N = 1e5 + 10;
const int INF = 1e9 + 10;
const int MOD = 1971971971, MOD2 = 1e9 + 7;

int n, m, a[N], b[N], pref[N], suf[N], deg[N], pref2[N], suf2[N], deg2[N], p = 203;

int mul(ll f, ll s, ll mod) {
    return f * s % mod;
}

int pl(ll f, ll s, ll mod) {
    return (f + s + mod) % mod;
}

ll pr1(int i) {
    if (i < 0) return 0;
    return pref[i + 1];
}

ll ps1(int i) {
    if (i >= n) return 0;
    return suf[i];
}

ll get_p1(int l, int r) {
    return pl(pr1(r), -mul(pr1(l - 1), deg[r - l + 1], MOD), MOD);
}

ll get_s1(int l, int r) {
    return pl(ps1(l), -mul(ps1(r + 1), deg[r - l + 1], MOD), MOD);
}


ll pr2(int i) {
    if (i < 0) return 0;
    return pref2[i + 1];
}

ll ps2(int i) {
    if (i >= n) return 0;
    return suf2[i];
}

ll get_p2(int l, int r) {
    return pl(pr2(r), -mul(pr2(l - 1), deg2[r - l + 1], MOD2), MOD2);
}

ll get_s2(int l, int r) {
    return pl(ps2(l), -mul(ps2(r + 1), deg2[r - l + 1], MOD2), MOD2);
}


int func(int L, int R) {
    int l = 0, r = min(n - R - 1, L) + 1;
    while (r - l > 1) {
        int mid = (l + r) >> 1;
        ((get_p1(L - mid, L) == get_s1(R, R + mid) && get_p2(L - mid, L) == get_s2(R, R + mid)) ? l : r) = mid;
    }
    return l * 2 + (L == R);
}

int main() {
#ifdef DEBUG
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
#endif
    fastio()

    cin >> n >> m;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int i = 0; i < m; ++i)
        cin >> b[i];

    bool ok = 1;
    int ans = 1;
    for (int i = 1; i < m; ++i)
        ok &= (b[i] == b[i - 1]);
    deg[0] = deg2[0] = 1;
    pref[0] = suf[n] = pref2[0] = suf2[0] = 0;

    assert(ok);
    for (int i = 0; i < n; ++i) {
        deg[i + 1] = mul(deg[i], p, MOD);
        pref[i + 1] = pl(mul(pref[i], p, MOD), a[i], MOD);
        deg2[i + 1] = mul(deg2[i], p, MOD2);
        pref2[i + 1] = pl(mul(pref2[i], p, MOD2), a[i], MOD2);
    }
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = pl(mul(suf[i + 1], p, MOD), a[i], MOD);
        suf2[i] = pl(mul(suf2[i + 1], p, MOD2), a[i], MOD2);
    }

    for (int i = 0; i < n; ++i) {
        ans = max(ans, func(i, i));
        if (i + 1 < n)
            ans = max(ans, func(i, i + 1));
    }
    cout << min(ans, m);
}
