#include <bits/stdc++.h>

using namespace std;

#define fastio() ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;

const int N = 1e5 + 10;
const int INF = 1e9 + 10;
const int MOD = 1e9 + 7;

int a[N], b[N];

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fastio()

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int i = 0; i < m; ++i)
        cin >> b[i];

    if (m < n) {
        for (int i = 0; i < n; ++i)
            swap(a[i], b[i]);
        swap(n, m);
    }

    int ans = 1;
    for (int len = 2; len <= n; ++len) {
        for (int l = 0; l + len <= n; ++len) {
            int r = l + len - 1;
            for (int L = 0; L + len <= m; ++L) {
                bool ok = 1;
                int R = L + len - 1;
                for (int i = 0; i < len; ++i) {
                    if (a[l + i] + b[L + i] != a[r - i] + b[R - i]) {
                        ok = 0;
                        break;
                    }
                }
                if (ok) ans = len;
            }
            if (ans == len) break;
        }
    }
    cout << ans;
}
