#include <bits/stdc++.h>

using namespace std;

#define fastio() ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;

const int N = 1e5 + 10;
const int INF = 1e9 + 10;
const int MOD = 1e9 + 7;

int a[N], b[N], h[N], H[N], p = 147;
unordered_map<int, bool> mp;

int mul(ll f, ll s) {
    return f * s % MOD;
}

int pl(ll f, ll s) {
    return (f + s + MOD) % MOD;
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fastio()

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int i = 0; i < m; ++i)
        cin >> b[i];

    if (m < n) {
        for (int i = 0; i < n; ++i)
            swap(a[i], b[i]);
        swap(n, m);
    }

    int ans = 1;
    for (int len = 2; len <= n; len += 2) {
        mp.clear();

        for (int i = 0; i + len <= n; ++i) {
            H[i] = pl(mul(H[i + 1], p), a[i] - a[i + len - 1]);
            mp[H[i]] = 1;
        }
        for (int i = 0; i + len <= m; ++i) {
            h[i] = pl(mul(h[i + 1], p), b[i + len - 1] - b[i]);
            if (mp.find(h[i]) != mp.end())
                ans = max(ans, len);
        }
    }
    for (int i = 0; i < n; ++i) H[i] = 0;
    for (int i = 0; i < m; ++i) h[i] = 0;

    for (int len = 3; len <= n; len += 2) {
        mp.clear();

        for (int i = 0; i + len <= n; ++i) {
            H[i] = pl(mul(H[i + 1], p), a[i] - a[i + len - 1]);
            mp[H[i]] = 1;
        }
        for (int i = 0; i + len <= m; ++i) {
            h[i] = pl(mul(h[i + 1], p), b[i + len - 1] - b[i]);
            if (mp.find(h[i]) != mp.end())
                ans = max(ans, len);
        }
    }

    cout << ans;
}
