#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second;
#define pb emplace_back
#define rall(x) x.rbegin() x.rend()
#define fastio() ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 1e6 + 10;

int n, q, k, a[N], b[N];
pii d[N];

bool cmp(pii f, pii s) {
    ld v = (ld) f.ff / f.ss;
    ld u = (ld) s.ff / s.ss;
    return v < u;
}

void less_n() { // O(n^2 * logn + t * logC)
    int p = 0;
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    for (int i = 0; i < n; ++i) {
        cin >> b[i];
        for (int j = 0; j < n; ++j)
            d[p++] = {a[j], b[i]};
    }
    sort(d, d + n * n, cmp);

    while (q--) {
        cin >> k;
        int f = d[k - 1].ff, s = d[k - 1].ss;
        cout << f / __gcd(f, s) << ' ' << s / __gcd(f, s) << '\n';
    }
}

void less_t() {
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int i = 0; i < n; ++i)
        cin >> b[i];
    sort(a, a + n);
    sort(b, b + n);
    reverse(b, b + n);

    while (q--) {
        cin >> k;

        ld l = 0, r = 1e2 + 1;
        for (int it = 0; it < 100; ++it) {
            int cnt = 0;
            ld need = (l + r) / 2;
            for (int i = 0; i < n; ++i) {
                int L = -1, R = n;
                while (R - L > 1) {
                    int m = (L + R) >> 1;
                    ((ld)a[i] / b[m] <= need ? L : R) = m;
                }
                cnt += R;
            }
            (cnt < k ? l : r) = need;
        }

        ld mx = -1;
        pii ans;
        for (int i = 0; i < n; ++i) {
            int L = -1, R = n;
            while (R - L > 1) {
                int m = (L + R) >> 1;
                ((ld)a[i] / b[m] <= r ? L : R) = m;
            }

            if (L == -1) continue;
            if ((ld)a[i] / b[L] > mx) {
                mx = (ld)a[i] / b[L];
                ans = {a[i], b[L]};
            }
        }

        int dd = __gcd(ans.ff, ans.second);
        cout << ans.ff / dd << ' ' << ans.second / dd << '\n';
    }
}

signed main() {
#ifdef DEBUG
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
#endif
    fastio()

    cin >> n >> q;
    (n <= 1000 ? less_n : less_t)();
}