#include <bits/stdc++.h>

using namespace std;

#define fastio() ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef long double ld;

const int N = 1e5;
const int INF = 1e9 + 10;
const ld EPS = 1e-6;

struct Ans {
    int a, b, c, d;
};

int n, t;
ld len[30][3];
vector<Ans> ans;
bool used[N];

int f(int a, int b, int c, int d) {
    int mas[4] = {a, b, c, d};
    sort(mas, mas + 4);
    return mas[0] + mas[1] * 31 + mas[2] * 31 * 31 + mas[3] * 31 * 31 * 31;
}

bool sr(ld a, ld b) {
    return abs(a - b) < EPS;
}

ld d(ld x, ld y, ld X, ld Y) {
    ld xx = x - X, yy = y - Y;
    return sqrtl(xx * xx + yy * yy);
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fastio()

    cin >> t >> n;
    for (int i = 0; i < n; ++i) {
        ld x, y, x2, y2, x3, y3;
        cin >> x >> y >> x2 >> y2 >> x3 >> y3;
        len[i][0] = d(x, y, x2, y2);
        len[i][1] = d(x2, y2, x3, y3);
        len[i][2] = d(x3, y3, x, y);

        if (len[i][0] == len[i][2]) {
            swap(len[i][0], len[i][2]);
            swap(len[i][1], len[i][2]);
        }
        if (len[i][1] == len[i][2]) {
            swap(len[i][0], len[i][1]);
            swap(len[i][1], len[i][2]);
        }
    }

    if (t == 3) {
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                for (int k = j + 1; k < n; ++k) {
                    for (int l = k + 1; l < n; ++l)
                        ans.push_back({i + 1, j + 1, k + 1, l + 1});
                }
            }
        }
    }
    else {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i == j) continue;
                for (int k = 0; k < n; ++k) {
                    if (i == k || j == k) continue;
                    for (int l = 0; l < n; ++l) {
                        if (l == i || l == j || l == k) continue;
                        if (used[f(i, j, l, k)]) continue;
                        if (sr(len[i][0], len[j][0]) && sr(len[i][1], len[l][1]) && sr(len[i][2], len[k][2])) {
                            used[f(i, j, l, k)] = 1;
                            ans.push_back({i, j, k, l});
                        }
                    }
                }
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto i: ans)
        cout << i.a << ' ' << i.b << ' ' << i.c << ' ' << i.d << '\n';
}