#include <bits/stdc++.h>

using namespace std;

#define pb emplace_back
#define rall(x) x.rbegin() x.rend()
#define fastio() ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef long long ll;
typedef pair<int, int> pii;

const int N = 1e5 + 10;

int n, k, a[N], b[N], ccc[N];
ll av[N], bv[N];
pii ed[N];
pair<int, ll> mas[N];
vector<pair<int, ll>> g[N];

bool cmp(pair<int, ll> aa, pair<int, ll> bb) {
    if (aa.first == bb.first)
        return aa.second < bb.second;
    return aa.first > bb.first;
}

void slow() {
    int ans = 0, cnt[N];
    ll cost = 0;
    for (int mask = 0; mask < (1 << (n - 1)); ++mask) {
        int cc = 0;
        ll cur = 0;
        for (int i = 0; i < n; ++i) cnt[i] = 0;
        for (int i = 0; i + 1 < n; ++i) {
            if ((mask >> i) & 1) {
                ++cc;
                cur += ccc[i];
                ++cnt[ed[i].first];
                ++cnt[ed[i].second];
            }
        }

        bool ok = 1;
        for (int i = 0; i < n; ++i) {
            if (cnt[i] > k) ok = 0;
        }
        if (ok) {
            if (cc > ans) {
                ans = cc;
                cost = cur;
            }
            else if (cc == ans)
                cost = min(cost, cur);
        }
    }
    cout << ans << ' ' << cost << '\n';
}

int dfs(int v) {
    int p = 0, K = k;
    for (auto [to, w] : g[v])
        dfs(to);
    for (auto [to, w] : g[v]) {
        a[v] += a[to];
        b[v] += a[to];
        av[v] += av[to];
        bv[v] += av[to];
        mas[p++] = {b[to] - a[to] + 1, bv[to] - av[to] + w};
    }

    sort(mas, mas + p, cmp);
    for (int i = 0; i < p && K; ++i) {
        if (mas[i].first < 0) continue;
        if (K > 1) {
            b[v] += mas[i].first;
            bv[v] += mas[i].second;
        }
        a[v] += mas[i].first;
        av[v] += mas[i].second;
        --K;
    }

    return max(a[v], b[v]);
}

int main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    fastio()
    cin >> n >> k;

    for (int i = 1, p, w; i < n; ++i) {
        cin >> p >> w;
        g[--p].pb(i, w);
        ed[i - 1] = {p, i};
        ccc[i - 1] = w;
    }

    slow();
    /*
    dfs(0);
    int v = 0;
    cout << max(a[v], b[v]) << ' ';
    if (a[v] > b[v]) cout << av[v];
    else if (a[v] == b[v]) cout << min(av[v], bv[v]);
    else cout << bv[v];
     */
}
